package org.gcube.portlets.user.workspace.client.event;

import org.gcube.portlets.user.workspace.client.interfaces.EventsTypeEnum;
import org.gcube.portlets.user.workspace.client.interfaces.GuiEventInterface;
import org.gcube.portlets.user.workspace.client.model.FileModel;

import com.google.gwt.event.shared.GwtEvent;

/**
 * @author Francesco Mangiacrapa francesco.mangiacrapa@isti.cnr.it
 *
 */
public class CompletedFileUploadEvent extends GwtEvent<CompletedFileUploadEventHandler> implements GuiEventInterface{
	public static Type<CompletedFileUploadEventHandler> TYPE = new Type<CompletedFileUploadEventHandler>();
	
	private FileModel parentFileModel;
	private String itemIdentifier;
	
	public CompletedFileUploadEvent(FileModel parent, String itemIdentifier) {
		this.parentFileModel = parent;
		this.itemIdentifier = itemIdentifier;
	}

	@Override
	public Type<CompletedFileUploadEventHandler> getAssociatedType() {
		return TYPE;
	}

	@Override
	protected void dispatch(CompletedFileUploadEventHandler handler) {
		handler.onCompletedFileUploadEvent(this);
	}

	@Override
	public EventsTypeEnum getKey() {
		return EventsTypeEnum.COMPLETED_FILE_UPLOAD_EVENT;
	}

	public FileModel getTargetFolderModel() {
		return parentFileModel;
	}

	public String getItemIdentifier() {
		return itemIdentifier;
	}
	
	
}
