package org.gcube.portlets.user.workspace.client.event;

import org.gcube.portlets.user.workspace.client.interfaces.EventsTypeEnum;
import org.gcube.portlets.user.workspace.client.interfaces.GuiEventInterface;
import org.gcube.portlets.user.workspace.client.model.FileModel;

import com.google.gwt.event.shared.GwtEvent;

public class FileUploadEvent extends GwtEvent<FileUploadEventHandler> implements GuiEventInterface{
	public static Type<FileUploadEventHandler> TYPE = new Type<FileUploadEventHandler>();
	public enum UploadType {ARCHIVE, FILE};
	private FileModel targetFolder = null;
	private UploadType uploadType;
	
	public FileUploadEvent(FileModel targetFolder, UploadType uploadType) {
		this.targetFolder = targetFolder;
		this.uploadType = uploadType;
	}

	@Override
	public Type<FileUploadEventHandler> getAssociatedType() {
		return TYPE;
	}

	@Override
	protected void dispatch(FileUploadEventHandler handler) {
		handler.onFileUploadEvent(this);
	}

	@Override
	public EventsTypeEnum getKey() {
		return EventsTypeEnum.FILE_UPLOAD_EVENT;
	}

	public FileModel getTargetFolderModel() {
		return targetFolder;
	}

	public UploadType getUploadType() {
		return uploadType;
	}
	
	public String getUploadTypeToString() {
		return uploadType.toString();
	}
	
}
