package org.gcube.portlets.user.workspace.client.event;

import org.gcube.portlets.user.workspace.client.interfaces.EventsTypeEnum;
import org.gcube.portlets.user.workspace.client.interfaces.GuiEventInterface;
import org.gcube.portlets.user.workspace.client.model.FileModel;

import com.google.gwt.event.shared.GwtEvent;

public class RefreshFolderEvent extends GwtEvent<RefreshItemEventHandler> implements GuiEventInterface {
	public static Type<RefreshItemEventHandler> TYPE = new Type<RefreshItemEventHandler>();
	
	private FileModel folderTarget= null;

	private boolean expandFolder = true; //DEFAULT EXPAND FOLDER

	private boolean forceRefresh;
	
	public RefreshFolderEvent(FileModel folderTarget, boolean expandFolder, boolean forceRefresh) {
		this.folderTarget = folderTarget;
		this.expandFolder = expandFolder;
		this.forceRefresh = forceRefresh;
	}
	

	@Override
	public Type<RefreshItemEventHandler> getAssociatedType() {
		return TYPE;
	}

	@Override
	protected void dispatch(RefreshItemEventHandler handler) {
		handler.onRefreshItem(this);
		
	}

	public FileModel getFolderTarget() {
		return folderTarget;
	}

	@Override
	public EventsTypeEnum getKey() {
		return EventsTypeEnum.REFRESH_FOLDER;
	}


	public boolean isExpandFolder() {
		return expandFolder;
	}


	public void setExpandFolder(boolean expandFolder) {
		this.expandFolder = expandFolder;
	}


	public boolean isForceRefresh() {
		return forceRefresh;
	}


	public void setForceRefresh(boolean forceRefresh) {
		this.forceRefresh = forceRefresh;
	}
}
