package org.gcube.portlets.user.workspace.client.model;

import java.io.Serializable;
import java.util.Comparator;

import com.extjs.gxt.ui.client.data.BaseModelData;

/**
 * @author Francesco Mangiacrapa francesco.mangiacrapa@isti.cnr.it
 *
 */
public class InfoContactModel extends BaseModelData implements Serializable {


	protected static final String ID = "id";
	public static final String FULLNAME = "fullname";
	public static final String LOGIN = "login";
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	public InfoContactModel() {}

	public InfoContactModel(String id, String login, String fullName) {
		setId(id);
		setLogin(login);
		setName(fullName);
	}
	
	public void setName(String name) {
		set(FULLNAME,name);
		
	}
	
	public String getName(){
		return get(FULLNAME);
	}

	public String getId() {
		return get(ID);
	}

	public void setId(String id) {
		set(ID, id);
	}

	public String getLogin() {
		return get(LOGIN);
	}

	public void setLogin(String login) {
		set(LOGIN, login);
	}

	
	public static Comparator<InfoContactModel> COMPARATOR = new Comparator<InfoContactModel>() {
		// This is where the sorting happens.
		public int compare(InfoContactModel o1, InfoContactModel o2) {
			return o1.getName().compareToIgnoreCase(o2.getName());
		}
	};

	@Override
	public String toString() {
		StringBuilder builder = new StringBuilder();
		builder.append("InfoContactModel [getName()=");
		builder.append(getName());
		builder.append(", getId()=");
		builder.append(getId());
		builder.append(", getLogin()=");
		builder.append(getLogin());
		builder.append("]");
		return builder.toString();
	}
	
	
}